#include "stdafx.h"
#include "Md5.h"
#include <strsafe.h>


// MD5Transform函数使用的常量;
#define S11 7  
#define S12 12  
#define S13 17  
#define S14 22  
#define S21 5  
#define S22 9  
#define S23 14  
#define S24 20  
#define S31 4  
#define S32 11  
#define S33 16  
#define S34 23  
#define S41 6  
#define S42 10  
#define S43 15  
#define S44 21  

// 基础的MD5函数（四个非线性函数（每轮一个））
#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define H(x, y, z) ((x) ^ (y) ^ (z))
#define I(x, y, z) ((y) ^ ((x) | (~z)))

// 将x左移n个bit位;
#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))

// FF, GG, HH, 和 II 是用来转换 Rounds1,2,3,4的 ;
// Rotation is separate from addition to prevent recomputation;
#define FF(a, b, c, d, x, s, ac) { \
	(a) += F ((b), (c), (d)) + (x) + (UINT32)(ac); \
	(a) = ROTATE_LEFT ((a), (s)); \
	(a) += (b); \
}
#define GG(a, b, c, d, x, s, ac) { \
	(a) += G ((b), (c), (d)) + (x) + (UINT32)(ac); \
	(a) = ROTATE_LEFT ((a), (s)); \
	(a) += (b); \
}
#define HH(a, b, c, d, x, s, ac) { \
	(a) += H ((b), (c), (d)) + (x) + (UINT32)(ac); \
	(a) = ROTATE_LEFT ((a), (s)); \
	(a) += (b); \
}
#define II(a, b, c, d, x, s, ac) { \
	(a) += I ((b), (c), (d)) + (x) + (UINT32)(ac); \
	(a) = ROTATE_LEFT ((a), (s)); \
	(a) += (b); \
}

static unsigned char PADDING[64] = {
	0x80, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0
};

CMD5::CMD5(void)
{
	m_nInputLen = 0;
	m_pInputText = NULL;
	m_bValidDigest = FALSE;
	memset(m_digestStr,0,33);
}

CMD5::CMD5(IN CONST BYTE* szInput,IN CONST size_t& nInputLen)
{
	m_pInputText =  const_cast<BYTE*>(szInput); 
	m_nInputLen = nInputLen;
	memset(m_digestStr, 0, 33);
	m_bValidDigest = CalcDigest();
}

CMD5::~CMD5(void)
{

}

void CMD5::Decode(IN UINT32 *output, IN UINT8 *input, IN CONST size_t& len)
{
	UINT32 i, j;
	for (i = 0, j = 0; j < len; i++, j += 4)
		output[i] = (input[j]) | ((input[j+1]) << 8) | ((input[j+2]) << 16) | ((input[j+3]) << 24);
}

void CMD5::Encode(IN UINT8 *output, IN UINT32 *input, IN CONST size_t& len)
{
	UINT32 i, j;
	for (i = 0, j = 0; j < len; i++, j += 4) 
	{
		output[j] = input[i] & 0xFF;
		output[j+1] = (input[i] >> 8) & 0xFF;
		output[j+2] = (input[i] >> 16) & 0xFF;
		output[j+3] = (input[i] >> 24) & 0xFF;
	}
}

void CMD5::MD5Init(IN MD5_CTX* md5ctx)
{
	md5ctx->count[0] = md5ctx->count[1] = 0;
	// 用魔数常量来初始化;
	md5ctx->state[0] = 0x67452301;
	md5ctx->state[1] = 0xefcdab89;
	md5ctx->state[2] = 0x98badcfe;
	md5ctx->state[3] = 0x10325476;
}

void CMD5::MD5Update(IN MD5_CTX* md5ctx, IN UINT8* Input, IN CONST size_t& InputLen)
{
	UINT32 i, nIndex, nPartLen;

	// 计算出模64（0x3F）后的值;
	nIndex = (md5ctx->count[0] >> 3) & 0x3F;

	// 更新bit位数;
	if ( (md5ctx->count[0] += (InputLen << 3))< (InputLen << 3) )
		md5ctx->count[1]++;
	md5ctx->count[1] += (InputLen >> 29);

	// 设置缓冲区的字节数;
	nPartLen = 64 - nIndex;

	// 尽可能多的转换;
	if (InputLen >= nPartLen) 
	{
		memcpy(&md5ctx->buffer[nIndex], Input, nPartLen);
		MD5Transform(md5ctx->state, md5ctx->buffer);

		for (i = nPartLen; i + 63 < InputLen; i += 64)
			MD5Transform(md5ctx->state, &Input[i]);

		nIndex = 0;
	}
	else
		i = 0;

	// 复制剩余的缓冲内容;
	memcpy(&md5ctx->buffer[nIndex], &Input[i], InputLen-i);
}

void CMD5::MD5Transform(IN UINT32 state[4], IN UINT8 block[64] )
{
	UINT32 a = state[0], b = state[1], c = state[2], d = state[3], x[16];

	Decode(x, block, 64);

	// 第一轮分组运算;
	FF(a, b, c, d, x[ 0], S11, 0xd76aa478); /* 1 */
	FF(d, a, b, c, x[ 1], S12, 0xe8c7b756); /* 2 */
	FF(c, d, a, b, x[ 2], S13, 0x242070db); /* 3 */
	FF(b, c, d, a, x[ 3], S14, 0xc1bdceee); /* 4 */
	FF(a, b, c, d, x[ 4], S11, 0xf57c0faf); /* 5 */
	FF(d, a, b, c, x[ 5], S12, 0x4787c62a); /* 6 */
	FF(c, d, a, b, x[ 6], S13, 0xa8304613); /* 7 */
	FF(b, c, d, a, x[ 7], S14, 0xfd469501); /* 8 */
	FF(a, b, c, d, x[ 8], S11, 0x698098d8); /* 9 */
	FF(d, a, b, c, x[ 9], S12, 0x8b44f7af); /* 10 */
	FF(c, d, a, b, x[10], S13, 0xffff5bb1); /* 11 */
	FF(b, c, d, a, x[11], S14, 0x895cd7be); /* 12 */
	FF(a, b, c, d, x[12], S11, 0x6b901122); /* 13 */
	FF(d, a, b, c, x[13], S12, 0xfd987193); /* 14 */
	FF(c, d, a, b, x[14], S13, 0xa679438e); /* 15 */
	FF(b, c, d, a, x[15], S14, 0x49b40821); /* 16 */

	// 第二轮分组运算;
	GG(a, b, c, d, x[ 1], S21, 0xf61e2562); /* 17 */
	GG(d, a, b, c, x[ 6], S22, 0xc040b340); /* 18 */
	GG(c, d, a, b, x[11], S23, 0x265e5a51); /* 19 */
	GG(b, c, d, a, x[ 0], S24, 0xe9b6c7aa); /* 20 */
	GG(a, b, c, d, x[ 5], S21, 0xd62f105d); /* 21 */
	GG(d, a, b, c, x[10], S22,  0x2441453); /* 22 */
	GG(c, d, a, b, x[15], S23, 0xd8a1e681); /* 23 */
	GG(b, c, d, a, x[ 4], S24, 0xe7d3fbc8); /* 24 */
	GG(a, b, c, d, x[ 9], S21, 0x21e1cde6); /* 25 */
	GG(d, a, b, c, x[14], S22, 0xc33707d6); /* 26 */
	GG(c, d, a, b, x[ 3], S23, 0xf4d50d87); /* 27 */
	GG(b, c, d, a, x[ 8], S24, 0x455a14ed); /* 28 */
	GG(a, b, c, d, x[13], S21, 0xa9e3e905); /* 29 */
	GG(d, a, b, c, x[ 2], S22, 0xfcefa3f8); /* 30 */
	GG(c, d, a, b, x[ 7], S23, 0x676f02d9); /* 31 */
	GG(b, c, d, a, x[12], S24, 0x8d2a4c8a); /* 32 */

	// 第三轮分组运算;
	HH(a, b, c, d, x[ 5], S31, 0xfffa3942); /* 33 */
	HH(d, a, b, c, x[ 8], S32, 0x8771f681); /* 34 */
	HH(c, d, a, b, x[11], S33, 0x6d9d6122); /* 35 */
	HH(b, c, d, a, x[14], S34, 0xfde5380c); /* 36 */
	HH(a, b, c, d, x[ 1], S31, 0xa4beea44); /* 37 */
	HH(d, a, b, c, x[ 4], S32, 0x4bdecfa9); /* 38 */
	HH(c, d, a, b, x[ 7], S33, 0xf6bb4b60); /* 39 */
	HH(b, c, d, a, x[10], S34, 0xbebfbc70); /* 40 */
	HH(a, b, c, d, x[13], S31, 0x289b7ec6); /* 41 */
	HH(d, a, b, c, x[ 0], S32, 0xeaa127fa); /* 42 */
	HH(c, d, a, b, x[ 3], S33, 0xd4ef3085); /* 43 */
	HH(b, c, d, a, x[ 6], S34,  0x4881d05); /* 44 */
	HH(a, b, c, d, x[ 9], S31, 0xd9d4d039); /* 45 */
	HH(d, a, b, c, x[12], S32, 0xe6db99e5); /* 46 */
	HH(c, d, a, b, x[15], S33, 0x1fa27cf8); /* 47 */
	HH(b, c, d, a, x[ 2], S34, 0xc4ac5665); /* 48 */

	// 第四轮分组运算;
	II(a, b, c, d, x[ 0], S41, 0xf4292244); /* 49 */
	II(d, a, b, c, x[ 7], S42, 0x432aff97); /* 50 */
	II(c, d, a, b, x[14], S43, 0xab9423a7); /* 51 */
	II(b, c, d, a, x[ 5], S44, 0xfc93a039); /* 52 */
	II(a, b, c, d, x[12], S41, 0x655b59c3); /* 53 */
	II(d, a, b, c, x[ 3], S42, 0x8f0ccc92); /* 54 */
	II(c, d, a, b, x[10], S43, 0xffeff47d); /* 55 */
	II(b, c, d, a, x[ 1], S44, 0x85845dd1); /* 56 */
	II(a, b, c, d, x[ 8], S41, 0x6fa87e4f); /* 57 */
	II(d, a, b, c, x[15], S42, 0xfe2ce6e0); /* 58 */
	II(c, d, a, b, x[ 6], S43, 0xa3014314); /* 59 */
	II(b, c, d, a, x[13], S44, 0x4e0811a1); /* 60 */
	II(a, b, c, d, x[ 4], S41, 0xf7537e82); /* 61 */
	II(d, a, b, c, x[11], S42, 0xbd3af235); /* 62 */
	II(c, d, a, b, x[ 2], S43, 0x2ad7d2bb); /* 63 */
	II(b, c, d, a, x[ 9], S44, 0xeb86d391); /* 64 */

	state[0] += a;
	state[1] += b;
	state[2] += c;
	state[3] += d;

	memset(x, 0, sizeof(x));
}

void CMD5::MD5Final(IN UINT8 digest[16], IN MD5_CTX* md5ctx)
{
	UINT8 bits[8];
	UINT32 index, padLen;

	// 保存2进制位数;
	Encode(bits, md5ctx->count, 8);

	/* Pad out to 56 mod 64.*/
	index = (unsigned int)((md5ctx->count[0] >> 3) & 0x3f);
	padLen = (index < 56) ? (56 - index) : (120 - index);
	MD5Update(md5ctx, PADDING, padLen);

	/* Append length (before padding) */
	MD5Update(md5ctx, bits, 8);

	/* Store state in digest */
	Encode(digest, md5ctx->state, 16);

	memset(md5ctx, 0, sizeof(*md5ctx));
}

void CMD5::SetBYTEText(IN CONST BYTE* szInput, IN CONST size_t& nInputLen)
{
	m_pInputText =  const_cast<BYTE*>(szInput); 
	m_nInputLen = nInputLen;
	m_bValidDigest = CalcDigest();
}

BOOL CMD5::CalcDigest()
{
	MD5_CTX md5ctx;
	// 初始化md5;
	MD5Init(&md5ctx); 
	MD5Update(&md5ctx, m_pInputText, m_nInputLen);
	MD5Final(m_digest,&md5ctx);

	// 转化为32位的16进制字符;
	int p = 0;
	for (int i = 0; i < 16; i++)
	{
#ifdef UNICODE
		StringCchPrintfW(&m_digestStr[p], 3, L"%02x", m_digest[i]);
#else
		StringCchPrintfA(&m_digestStr[p], 3, "%02x", m_digest[i]);
#endif
		p += 2;
	}

	return TRUE;
}

CONST TCHAR* CMD5::GetMD5Digest()
{
	if( m_bValidDigest )
		return m_digestStr;

	return NULL;
}

std::string GetTextMD5(std::string text)
{
	CMD5 md5;
	md5.SetBYTEText((const byte*)text.c_str(), text.size());
	return std::string(md5.GetMD5Digest());
}

std::string GetFileMD5(std::string file)
{
	CMD5 md5;
	FILE *pf = NULL;
	if ( _tfopen_s(&pf, file.c_str(), "rb") == 0 )
	{
		fseek(pf, 0, SEEK_END);
		size_t fsize = ftell(pf);
		fseek(pf, 0, SEEK_SET);

		byte* pdata = new byte[fsize];
		fread(pdata, 1, fsize, pf);
		md5.SetBYTEText(pdata, fsize);

		delete []pdata;
		pdata = NULL;

		fclose(pf);

		return std::string(md5.GetMD5Digest());
	}

	return std::string();
}
